﻿Public Class Form1
    Private g As Graphics
    Private req As Net.HttpWebRequest
    Private HorizontalOffset As Integer = 0
    Private VerticalOffset As Integer = 0
    Private Mousestart As Point
    Private horstart As Integer
    Private verstart As Integer
    Private Moving As Boolean
    Private deltay As Integer = 0
    Private deltax As Integer = 0
    Private zoomin As Integer = 0
    Private currx As Integer = 0
    Private curry As Integer = 0
    Private towns As List(Of Town)
    Private nearbytowns As List(Of Town)


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        AddHandler MouseWheel, AddressOf Zoom
        AddHandler ListBox1.MouseWheel, AddressOf Zoom
        towns = Town.LoadTown("http://" & txtServer.Text & "/obce.xml")
        Draw()
    End Sub

    Private Sub Draw()
        PictureBox1.Image = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        g = Graphics.FromImage(PictureBox1.Image)

        'Pokud jsou offsety větší než velikost jednoho políčka, program změní "středové políčko"
        While HorizontalOffset < -128
            HorizontalOffset += 256
            deltax -= 1
        End While

        While HorizontalOffset > 128
            HorizontalOffset -= 256
            deltax += 1
        End While


        While VerticalOffset > 128
            VerticalOffset -= 256
            deltay += 1
        End While

        While VerticalOffset < -128
            VerticalOffset += 256
            deltay -= 1
        End While

        'Nakreslení středového políčka
        DrawMapField(New Point(PictureBox1.Width / 2 - 128 - HorizontalOffset, PictureBox1.Height / 2 - 128 - VerticalOffset), currx + deltax, curry + deltay, zoomin, txtServer.Text, g)

        'Nakreslení všech viditelných sousedů
        DrawNeighbors(currx + deltax, curry + deltay, zoomin, PictureBox1.Size, txtServer.Text, g)
    End Sub
    Private Sub btnGoTo_Click(sender As Object, e As EventArgs) Handles btnGoTo.Click 'Přejde na požadované souřadnice
        HorizontalOffset = 0
        VerticalOffset = 0
        deltax = 0
        deltay = 0
        zoomin = NumericUpDownZ.Value
        curry = NumericUpDownY.Value
        currx = NumericUpDownZ.Value
        Draw()
    End Sub

    Private Sub DrawMapField(position As Point, x As Integer, y As Integer, z As Integer, server As String, g As Graphics) 'Nakreslí jedno políčko
        req = Net.HttpWebRequest.Create("http://" & server & "/" & z & "/" & x & "/" & y & ".jpg")
        Dim img As Image
        Try
            img = Image.FromStream(req.GetResponse.GetResponseStream)
        Catch ex As System.Net.WebException
            img = My.Resources.NotFound
        End Try
        g.DrawImage(img, New Rectangle(position, New Size(256, 256)))
    End Sub

    Private Sub DrawHorizontalNeighbors(x As Integer, y As Integer, z As Integer, limit As Size, server As String, g As Graphics, position As Integer)
        'Kreslí horiznotální sousedy
        Dim i As Integer = 1
        'Nejprve směrem doleva
        While limit.Width / 2 - 128 - 256 * (i - 1) > 0
            DrawMapField(New Point(limit.Width / 2 - 128 - 256 * i - HorizontalOffset, position - VerticalOffset), x - i, y, z, server, g)
            i += 1
        End While
        i = 1
        'A poté doprava
        While limit.Width / 2 - 128 + 256 * (i - 1) < limit.Width
            DrawMapField(New Point(limit.Width / 2 - 128 + 256 * i - HorizontalOffset, position - VerticalOffset), x + i, y, z, server, g)
            i += 1
        End While
    End Sub

    Private Sub DrawNeighbors(x As Integer, y As Integer, z As Integer, limit As Size, server As String, g As Graphics)
        'Nejprve nakreslí horizontální sousedy středového políčka
        DrawHorizontalNeighbors(x, y, z, limit, server, g, limit.Height / 2 - 128)
        Dim j As Integer = 1
        'Pak vykreslí všechny sousedy směrem nahoru a jejich horizontální sousedy
        While limit.Height / 2 - 128 - 256 * (j - 1) > 0
            DrawMapField(New Point(limit.Width / 2 - 128 - HorizontalOffset, limit.Height / 2 - 128 - 256 * j - VerticalOffset), x, y - j, z, server, g)
            DrawHorizontalNeighbors(x, y - j, z, limit, server, g, limit.Height / 2 - 128 - 256 * j)
            j += 1
        End While
        j = 1
        'A nakonec směrem dolů
        While limit.Height / 2 - 128 + 256 * (j - 1) < limit.Height
            DrawMapField(New Point(limit.Width / 2 - 128 - HorizontalOffset, limit.Height / 2 - 128 + 256 * j - VerticalOffset), x, y + j, z, server, g)
            DrawHorizontalNeighbors(x, y + j, z, limit, server, g, limit.Height / 2 - 128 + 256 * j)
            j += 1
        End While
    End Sub


    Private Sub PictureBox1_MouseDown(sender As Object, e As MouseEventArgs) Handles PictureBox1.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then Mousestart = e.Location
    End Sub

    Private Sub PictureBox1_MouseUp(sender As Object, e As MouseEventArgs) Handles PictureBox1.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Moving = False
            HorizontalOffset += Mousestart.X - e.Location.X
            VerticalOffset += Mousestart.Y - e.Location.Y
            Draw()
        End If
    End Sub

    Private Sub Zoom(sender As Object, e As System.Windows.Forms.MouseEventArgs)
        'Zoomování kolečkem
        If e.Delta > 0 And zoomin < 9 Then
            zoomin += 1
            currx = (currx + deltax) * 2
            curry = (curry + deltay) * 2
            deltax = 0
            deltay = 0
            VerticalOffset += 128
            HorizontalOffset += 128
            Draw()
        ElseIf e.Delta < 0 And zoomin > 0 Then
            zoomin -= 1
            currx = (currx + deltax) / 2
            curry = (curry + deltay) / 2
            deltax = 0
            deltay = 0
            VerticalOffset -= 128
            HorizontalOffset -= 128
            Draw()
        End If
    End Sub

    Private Function GetTowns(name As String) As List(Of Town)
        Dim towns2 As New List(Of Town)
        For Each mesto As Town In towns
            If mesto.Name.IndexOf(name, StringComparison.CurrentCultureIgnoreCase) = 0 And mesto.Name.Length = name.Length Then
                towns2.Add(mesto)
            End If
        Next
        Return towns2
    End Function

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        ListBox1.Items.Clear()
        ListBox1.Items.AddRange(GetTowns(TextBox1.Text).ToArray)
        ListBox1.Show()
    End Sub

    Private Sub GoToTown(mesto As Town)
        currx = Math.Floor((mesto.Location.X / (2 ^ (9 - zoomin))) / 256)
        HorizontalOffset = (mesto.Location.X / (2 ^ (9 - zoomin))) - currx * 256
        curry = Math.Floor((mesto.Location.Y / (2 ^ (9 - zoomin))) / 256)
        VerticalOffset = (mesto.Location.X / (2 ^ (9 - zoomin))) - currx * 256
        deltax = 0
        deltay = 0
        Draw()
    End Sub


    Private Sub ListBox1_DoubleClick(sender As Object, e As EventArgs) Handles ListBox1.DoubleClick
        GoToTown(ListBox1.SelectedItem)
    End Sub


    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        towns = Town.LoadTown("http://" & txtServer.Text & "/obce.xml")
        Draw()
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        zoomin += 1
        currx = (currx + deltax) * 2
        curry = (curry + deltay) * 2
        deltax = 0
        deltay = 0
        VerticalOffset += 128
        HorizontalOffset += 128
        Draw()
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        zoomin -= 1
        currx = (currx + deltax) / 2
        curry = (curry + deltay) / 2
        deltax = 0
        deltay = 0
        VerticalOffset -= 128
        HorizontalOffset -= 128
        Draw()
    End Sub


    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        HorizontalOffset -= 20
        Draw()
    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        VerticalOffset -= 20
        Draw()
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        HorizontalOffset += 20
        Draw()
    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        VerticalOffset += 20
        Draw()
    End Sub
End Class
