﻿Imports System.Xml
Public Class Town
    Public Name As String
    Public Location As Point

    Shared Function LoadTown(xmlpath As String) As List(Of Town)
        Dim doc As New XmlDocument
        doc.Load(xmlpath)
        Dim towns As New List(Of Town)
        For Each node As XmlNode In doc.SelectNodes("/obce/obec")
            towns.Add(New Town(node.Attributes.GetNamedItem("jméno").InnerText, New Point(node.Attributes.GetNamedItem("x").InnerText, node.Attributes.GetNamedItem("y").InnerText)))
        Next
        Return towns
    End Function

    Public Sub New()

    End Sub

    Public Sub New(Name As String, Location As Point)
        Me.Name = Name
        Me.Location = Location
    End Sub

    Public Overrides Function ToString() As String
        Return Me.Name
    End Function

    Public Function MeasureLength(x As Integer, y As Integer) As Double
        Return Math.Sqrt(((Me.Location.X - x) ^ 2) + ((Me.Location.Y - y) ^ 2)) / 256 * 395
    End Function
End Class

Public Class LengthComparer
    Implements IComparer

    ' Calls CaseInsensitiveComparer.Compare with the parameters reversed. 
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
       Implements IComparer.Compare
        Return New CaseInsensitiveComparer().Compare(y, x)
    End Function 'IComparer.Compare

End Class 'myReverserClass
